import javax.swing.*;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.util.Random;

/**
 * Created by Administrator on 2023/11/19.
 */
public class Stone extends JFrame implements KeyListener{
    private int[][] data = {
            {0,1,2,3},
            {4,5,6,7},
            {8,9,10,11},
            {12,13,14,15},
    };
    private int row;
    private int column;
    private int count;

    public Stone(){
        // 为窗体注册监听事件
        this.addKeyListener(this);

        // 初始化窗体
        init();
        // 初始化数据
        initData();
        // 绘制图形
        paintView();

        setVisible(true);
    }

    private void initData() {
        Random random = new Random();
        for (int j = 0; j <4 ; j++) {
            for(int i=0;i<4;i++){
              int x = random.nextInt(4);
              int y = random.nextInt(4);
                int temp =  data[j][i];
                data[j][i] = data[x][y];
                data[x][y] = temp;

            }
        }
        // 纪录空白块位置
        // 记录0号的位置
        for (int i = 0; i < 4; i++) {
            for (int j = 0; j < 4; j++) {
                if(data[i][j] == 0){
                    row = i;
                    column = j;
                }
            }
        }
    }

    private void paintView() {
        getContentPane().removeAll();

        // 取消焦点
        setFocusable(false);



        // 绘制一张图片
        for (int j = 0; j <4 ; j++) {
            for(int i=0;i<4;i++){
                JLabel jLabel = new JLabel(new ImageIcon("D:\\image\\"+data[j][i]+".png"));
                jLabel.setBounds(100*i+50,j*100+90,100,100);
                getContentPane().add(jLabel);
            }
        }
        // 绘制背景
        JLabel jLabel = new JLabel(new ImageIcon("D:\\image\\background.png"));
        jLabel.setBounds(26,30,450,484);
        getContentPane().add(jLabel);




        getContentPane().repaint();


    }


    // 初始化窗体
    private void init() {
        // 设置窗体大小
        setSize(514,595);
        // 设置窗体标题
        setTitle("石头迷阵V1.0");
        // 设置关闭模式
        setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        setLocationRelativeTo(null);
        setAlwaysOnTop(true);
        // 取消默认布局
        setLayout(null);
    }

    @Override
    public void keyTyped(KeyEvent e) {

    }

    @Override
    public void keyPressed(KeyEvent e) {
        int temp;
        int keyCode = e.getKeyCode();
        switch (keyCode){
            case 37:
                System.out.println("左");
                // 边界判断
                if(row ==3){
                    return;
                }
               
                temp = data[row][column];
                data[row][column] = data[row][column+1];
                data[row][column+1] = temp;
                column++;
                break;
            case 38:
                System.out.println("上");
                // 边界判断
                if(row ==3){
                    return;
                }
                System.out.println("上");
                // 0下边的和0交换
                temp = data[row][column];
                data[row][column] = data[row+1][column];
                data[row+1][column] = temp;
                row++;
                count++;
                break;
            case 39:
                System.out.println("右");
                if(column == 0){
                    return;
                }
                System.out.println("右");
                // 0左边的和0交换
                temp = data[row][column];
                data[row][column] = data[row][column-1];
                data[row][column-1] = temp;
                column--;
                count++;
                break;
            case 40:
                System.out.println("下");
                if(row == 0){
                    return;
                }
                System.out.println("下");
                // 0上边的和0交换
                temp = data[row][column];
                data[row][column] = data[row-1][column];
                data[row-1][column] = temp;
                row--;
                count++;
                break;
        }
        paintView(); // 重新绘制
    }

    @Override
    public void keyReleased(KeyEvent e) {

    }
}
