import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.util.Random;

/**
 * Created by Administrator on 2023/11/26.
 */
public class MainFrame extends JFrame implements KeyListener{
    private  int[][] data = {
            {1,2,3,4},
            {5,6,7,8},
            {9,10,11,12},
            {13,14,15,0},
    };
    private  int[][] win = {
            {1,2,3,4},
            {5,6,7,8},
            {9,10,11,12},
            {13,14,15,0},
    };
    // 0号的位置
    int row;
    int column;
    // 初始步数
    int count;
    // 构造方法
    MainFrame(){
        // 增加键盘事件
        this.addKeyListener(this);
        // 初始化窗体
        initFrame();
        // 打乱
        initData();
        // 绘制游戏
        paintView();
        // 2.显示
        setVisible(true);
    }

    // 初始化窗体
    void initFrame(){

        // 1.绘制窗体

        // 2.设置窗体大小
        setSize(514,595);
        // 3.设置标题文字
        setTitle("石头迷阵单机版V1.0");
        // 6.关闭窗体 结束游戏
        setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        // 取消默认布局
        setLayout(null);
        // 4.窗口居中显示
        setLocationRelativeTo(null);
        // 5.窗口置于顶层
        setAlwaysOnTop(true);

    }

    // 打乱石块
    void initData(){
        Random random = new Random();
        // 遍历数组中的每一个元素，和产生的随机坐标交换位置
        for (int j=0;j<4;j++){
            for(int i=0;i<4;i++){
                // 产生一个随机的索引
                int x = random.nextInt(4);
                int y = random.nextInt(4);
//                System.out.println(data[j][i]);
//                System.out.println("-----------");
//                System.out.println(data[x][y]);
                int temp = data[j][i];
                data[j][i]= data[x][y];
                data[x][y] = temp;

            }
        }
        // 记录0号的位置
        for (int j=0;j<4;j++){
            for(int i=0;i<4;i++){
                if(data[j][i] == 0){
                   row = j;
                    column = i;
                }
            }
        }
        System.out.println(row);
        System.out.println(column);
    }

    // 绘制游戏界面
    void paintView(){
        // 1.清除原来的界面
      getContentPane().removeAll();
        // 如果赢了 显示胜利的图片
        if(victory()){
            // 1.加载一张胜利的图片
            JLabel jLabel1 = new JLabel(new ImageIcon("D:\\image\\win.png"));
            // 设置石头块的位置
            jLabel1.setBounds(124,230,266,88);
            // 添加石头块到窗体中
            getContentPane().add(jLabel1);
        }
        // 统计步数
        JLabel text = new JLabel("步数："+count);
        // 设置石头块的位置
        text.setBounds(50,20,100,20);
        // 添加石头块到窗体中
        getContentPane().add(text);
        // 重新游戏的按钮
        JButton jButton = new JButton("重新游戏");
        // 取消默认焦点
        jButton.setFocusable(false);
        jButton.setBounds(350,20,100,20);
        getContentPane().add(jButton);

        // 点击重新游戏 添加点击事件
        jButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                // 1.步数归零
                count = 0;
                // 2.打乱数据
                initData();
                // 3.重新绘制
                paintView();
            }
        });

        for (int j = 0; j < 4; j++) {
            for(int i=0;i<4;i++){
                // 绘制石头块图片
                JLabel jLabel1 = new JLabel(new ImageIcon("D:\\image\\"+data[j][i]+".png"));
                // 设置石头块的位置
                jLabel1.setBounds(50+i*100,90+100*j,100,100);
                // 添加石头块到窗体中
                getContentPane().add(jLabel1);
            }
        }
        // 背景图片
        JLabel bg = new JLabel(new ImageIcon("D:\\image\\background.png"));
        // 设置石头块的位置
        bg.setBounds(26,30,450,484);
        // 添加石头块到窗体中
        getContentPane().add(bg);
        // 2.重新绘制最新的界面
        getContentPane().repaint();
    }

    public void keyTyped(KeyEvent e) {

    }

    public void keyPressed(KeyEvent e) {
        // 键盘事件
        // 移动方块
        move(e.getKeyCode());
        // 重新绘制游戏界面
        paintView();
    }

    private void move(int keyCode) {
        // 如果胜利了， 就不能在上 下 左 右了
        if(victory()){
            return;
        }
        int temp;
        switch (keyCode){
            case 37:
                if(column == 3){
                    return;
                }
                System.out.println("左~~~~~~");
//                data[row][colmun]  data[row][column+1]
                temp = data[row][column];
                data[row][column] = data[row][column+1];
                data[row][column+1] = temp;
                // 重新计算最新的空白块的位置
                column++;
                count++;
                break;
            case 38:
                if(row == 3){
                    return;
                }
                System.out.println("上~~~~~~");
//                data[row][colmun]  data[row+1][column]
                temp = data[row][column];
                data[row][column] = data[row+1][column];
                data[row+1][column] = temp;
                row++;
                count++;
                break;
            case 39:
                if(column == 0){
                    return;
                }
                System.out.println("右~~~~~~");
//                data[row][colmun]  data[row][column-1]
                temp = data[row][column];
                data[row][column] = data[row][column-1];
                data[row][column-1] = temp;
                column--;
                count++;
                break;
            case 40:
                if(row == 0){
                    return;
                }
                System.out.println("下~~~~~~");
//                data[row][colmun]  data[row-1][column]
                temp = data[row][column];
                data[row][column] = data[row-1][column];
                data[row-1][column] = temp;
                row--;
                count++;
                break;
            case 90:
                // 作弊器
                data = new int[][]{
                        {1,2,3,4},
                        {5,6,7,8},
                        {9,10,11,12},
                        {13,14,15,0},
                };

        }
    }

    public void keyReleased(KeyEvent e) {

    }

    // 判断是否胜利
    public boolean victory(){
        for (int j=0;j<4;j++){
            for (int i = 0; i <4 ; i++) {
                if(data[j][i] != win[j][i]){
                    return false;
                }
            }
        }

        return true;
    }
}
